import Action from '@overflow/commons/redux/Action';
import createReducer from '@overflow/commons/redux/createReducer';
import Member from '@overflow/member/api/model/Member';

import * as SigninActionTypes from '../action/signIn';
import SigninState, { defaultState as signinDefaultState } from '../state/SignIn';

export type reducer = (state: SigninState, action: Action<Member | Error>) => SigninState;

export const reducer: reducer = createReducer(signinDefaultState, {
  [SigninActionTypes.REQUEST_SUCCESS]: (state: SigninState, action: Action<Member>): SigninState => {
    return state;
  },
  [SigninActionTypes.REQUEST_FAILURE]: (state: SigninState, action: Action<Error>): SigninState => {
    return state;
  },
});


// export const reducer: reducer = (state: SigninState = signinDefaultState, action: Action<Member | Error>): SigninState => {
//   switch (action.type) {
//     case SigninActionTypes.REQUEST_SUCCESS:
//     {
//       let member = (<Action<Member>>action).payload;

//       const aaa: SigninState = {
//         ...state,
//         isAuthenticated: true,
//       };

//       return aaa;
//     }
//     case SigninActionTypes.REQUEST_FAILURE:
//     {
//       return state;
//     }
//     default:
//       return state;
//   }
// };
